/// <summary>
///  Personaje: el elemento que mueve el usuario
///  @author Nacho Cabanes
///  @see Hardware Juego ElemGrafico
/// </summary>

/* --------------------------------------------------         
   Parte de FreddyTwo
 
   Versiones hasta la fecha:
   
   Num.   Fecha       Por / Cambios
   ---------------------------------------------------
   0.01  03-Feb-2012  Nacho Cabanes
                      Versin inicial: desglosado a partir de 
                        FreddyOne (Juego.cs)
 ---------------------------------------------------- */

public class Personaje : ElemGrafico
{
    // Atributos

    //private int vidas;

    // Asociaciones

    private Partida miPartida;

    // Operaciones

    public Personaje(Partida p)
        : base(4, 32, 23)  // Elemento grfico con (supuestamente) 4 direcciones
    {
        miPartida = p;
        xInicial = 400;
        yInicial = 300;
        x = xInicial;
        y = yInicial;
        visible = true;
        incrX = 10;
        incrY = 10;
        CargarSecuencia(DERECHA,new string[] { "personajed1.png", "personajed2.png" });
        CargarSecuencia(IZQUIERDA, new string[] { "personajei1.png", "personajei2.png" });
        CambiarDireccion(DERECHA);
    }

    /// Devuelve el personaje a su posicin inicial
    public void Reiniciar()
    {
        x = xInicial;
        y = yInicial;
    }

    /// Hace que el personaje comience a saltar
    public  void Saltar()
    {
        // TODO: Pendiente de completar
    }

    /// Hace que el personaje "lance" un disparo
    public  void Disparar()
    {
        // TODO: Pendiente de completar
    }

    /// Mueve el personaje hacia arriba (si es posible en el nivel actual)
    /// Las comprobaciones deben hacerse "fuera", antes de llamar a MoverDerecha
    public void MoverArriba()
    {
        SiguienteFotograma();
        y -= incrY;
    }

    /// Mueve el personaje hacia abajo (si es posible en el nivel actual)
    /// Las comprobaciones deben hacerse "fuera", antes de llamar a MoverIzquierda
    public void MoverAbajo()
    {
        SiguienteFotograma();
        y += incrY;
    }

    /// Mueve el personaje a la derecha (si es posible en el nivel actual)
    /// Las comprobaciones deben hacerse "fuera", antes de llamar a MoverDerecha
    public  void MoverDerecha()
    {
        CambiarDireccion(DERECHA);
        SiguienteFotograma();
        x += incrX;
    }

    /// Mueve el personaje a la izquierda (si es posible en el nivel actual)
    /// Las comprobaciones deben hacerse "fuera", antes de llamar a MoverIzquierda
    public  void MoverIquierda()
    {
        CambiarDireccion(IZQUIERDA);
        SiguienteFotograma();
        x -= incrX;
    }

    /// Hace que el personaje "baje" si no tiene suelo debajo
    public  void Caer()
    {
        y += incrY;
    }


    /// Hace que el personaje se siga moviendo (si debe hacerlo)
    /// De momento, slo llama a "Caer"
    public void Mover()
    {
        if (miPartida.EsPosibleMover(x,y+incrY,
                x+ancho,y+alto+incrY))
            Caer();
    }


} /* Fin de la clase Personaje */
